Name:       smatch
Version:    1.73
Release:    2%{?dist}
Summary:    A static analyzer for C

License:    GPL-2.0-or-later AND MIT AND BSD-3-Clause
URL:        https://%{name}.sourceforge.net

Source0:    https://github.com/error27/%{name}/archive/%{version}/%{name}-%{version}.tar.gz

Patch0:     do-not-build-sparse-binaries.patch
Patch1:     fix-datadir-path.patch
Patch2:     use-distribution-ldflags.patch
Patch3:     preserve-install-timestamps.patch
Patch4:     add-BSD-3-license.patch

BuildRequires: gcc
BuildRequires: make
BuildRequires: openssl-devel
BuildRequires: sqlite-devel

Requires: %{name}-data = %{version}-%{release}

Provides: bundled(cwchash)
Provides: bundled(sparse)

%description
Smatch is a static analysis tool for C.

%package data
Summary: Data for Smatch the C static analyzer
BuildArch: noarch
Requires: %{name} = %{version}-%{release}

%description data
Data for Smatch the static analysis tool for C.

%prep
%autosetup

%build
%set_build_flags
export CFLAGS="-std=gnu99 $CFLAGS"

%make_build PREFIX='%{_prefix}'

%install
%make_install PREFIX='%{_prefix}'

%check
echo "int main(void) { int a; return a; }" > test.c
./smatch test.c > out
grep "test.c:1 main() error: uninitialized symbol 'a'." out

%files
%doc README Documentation/{arm64-detecting-tagged-addresses,smatch}.txt
%license GPL-2 LICENSE
%{_bindir}/%{name}

%files data
%{_datadir}/%{name}

%changelog
* Fri Jun 13 2025 bbrucezhang <bbrucezhang@tencent.com> - 1.73-2
- Rebuilt for loongarch64

* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.73-1
- initial build
